import { Injectable } from '@angular/core';
import { Observable, throwError, of } from 'rxjs';
import { catchError, retry } from 'rxjs/operators';
import { HttpClient } from '@angular/common/http';

import { Hero } from './hero';
import { MessageService } from './message.service';

@Injectable({
  providedIn: 'root'
})
export class HeroService {
  constructor(private messageService: MessageService, private http: HttpClient) { }

  getHeroes(): Observable<Hero[]> {
    this.messageService.add('HeroService: fetched heroes');
    return this.http.get<Hero[]>(`/heroes`)
  }

  getHero(id: number): Observable<any> {
    this.messageService.add(`HeroService: fetch hero id=${id}`);
    return this.http.get<Hero>(`/hero?id=${id}`)
  }

  updateHero(hero: Hero): Observable<any> {
    this.messageService.add(`HeroService: save change: id=${hero.id}, name=${hero.name}`);
    return of(true);
  }
}
